# Creating Your Plutus Project: Step-by-Step Guide

---

<br />

To initiate your Plutus project effectively, follow these comprehensive steps to create your cabal.project file and set up your development environment:


### Step 1: Navigate to the Plutus-Apps Repository

-   Visit the [Plutus-Apps repository](https://github.com/input-output-hk/plutus-apps).

### Step 2: Choose a Version

-   You have the option to choose either a specific release version or a commit hash.
-   For a release version, click on [release/tags](https://github.com/input-output-hk/plutus-apps/tags), and select the version you prefer.
-   If you prefer a specific commit hash, go to the [commit](https://github.com/input-output-hk/plutus-apps/commits/main) page and find the hash you want to use.

### Step 3: Clone the Plutus-Apps Repository

-   Ensure you have already cloned the Plutus-Apps repository using `git clone` or that you are inside your existing clone.

### Step 4: Set Up the Nix Development Environment

-   Open your terminal and navigate to the Plutus-Apps directory:

```bash
$ cd plutus-apps
```

-   Update the repository and check out the version you selected (either a tag or commit hash):

```bash
$ git pull
$ git checkout <TAG_OR_COMMIT_HASH>
```

-   Initialize the Nix development environment:

```bash
$ nix develop
```

### Step 5: Create Your Plutus Project Folder

-   In your terminal, create a folder for your Plutus project, replacing `YOUR_PROJECT_NAME` with your chosen project name:

```bash
$ mkdir YOUR_PROJECT_NAME
$ cd YOUR_PROJECT_NAME
```

-   Create the `cabal.project` file:

```bash
$ touch cabal.project
```

### Step 6: Populate Your `cabal.project` File

-   Now, you need to populate your `cabal.project` file with package information based on the Plutus-Apps version you selected.

-   For a release version:

    -   Click on the short form of the commit hash next to the release date.
        On the right side, click on "Browse files."

-   For a commit hash:

    -   Search for the commit hash in the search bar:

    ```sh
    repo:IntersectMBO/plutus-apps <COMMIT_HASH>
    ```

    -   Click on the search result that corresponds to the commit.
    -   Locate the "Browse files" button in the top right corner and click it.

-   In either case, you will reach the version of Plutus-Apps associated with your selected tag or commit hash.
-   Find the `cabal.project` file in that page and click on it.
-   Click the "Raw" button to obtain the content of the `cabal.project` file.
-   Copy the content.

### Step 6: Edit Your cabal.project File

Paste the copied content inside your `cabal.project` file within your project folder.
At the end of the copied content, add the following lines, replacing `<THE_TAG_OR_COMMIT_HASH_YOU_HAVE_CHOOSE>` with your selected tag or commit hash:

```sh
source-repository-package
    type: git
    location: https://github.com/input-output-hk/plutus-apps.git
    tag: <THE_TAG_OR_COMMIT_HASH_YOU_HAVE_CHOOSE>
    subdir:

```

-   Find the `packages:` section in your `cabal.project` file.
-   Cut the `packages:` line from its current position and paste it beneath or under the `subdir` line within the `source-repository-package` section you added.
-   With these steps completed, you will have successfully initiated your Plutus project, configured your development environment, and set up your `cabal.project` file with the required package information. This prepares you for next step which creation of your project `.cabal` file.

<br />

# Creation of Cabal file

---

<br />

Now that we have our `cabal.project` file in place, we can proceed to create the `.cabal` file for your Plutus project. The `.cabal` file is essential for specifying project metadata and configurations. Below is a step-by-step guide:

### Step 1: create `.cabal` file:

-   Open your terminal and navigate to your project directory.

-   Create a `.cabal` file, replacing `<YOUR_PROJECT_NAME>` with the name of your project:

```sh
$ touch <YOUR_PROJECT_NAME>.cabal
```

### Step 2: Define Project Metadata

This section is dedicated to defining important metadata about your project, providing crucial information for its management and distribution. Here's a template for this section:

```text
-- Specifies the version of the Cabal specification used for this project.
Cabal-Version:            3.0

-- The name of the Plutus project, in this case, "token-vesting".
Name:                     token-vesting

-- The version number of the project. This helps in managing different versions of your project.
Version:                  1.0.0

-- The author or organization responsible for creating the project, in this case, "Gimbalabs".
Author:                   Gimbalabs

-- Indicates the build type, "Simple" in this case, which is suitable for most projects.
Build-Type:               Simple

-- Specifies the project's license. Here, it's licensed under GPL version 3.0 or later.
License:                  GPL-3.0-or-later

-- References the file that contains the full text of the project's license for reference.
License-file:             LICENSE

```

### Step 3: Common Project Configuration

-   In this section, you can define common project configurations, such as language extensions and GHC (Glasgow Haskell Compiler) options.
-   Language Extensions:
    -   Language extensions serve as a powerful tool for enabling specific language features in Haskell. They allow you to enhance the capabilities of your code when needed. You can selectively enable these extensions in your smart contract files using the LANGUAGE pragma: `{-# LANGUAGE <Extension>, <Extension> #-}`.
    -   To determine which language extensions are suitable for your project, you can refer to the extensive list of available extensions. Each extension provides unique functionalities that can be beneficial in particular scenarios, so researching and choosing the right ones can greatly enhance your project's capabilities.
-   GHC Options (Compiler Flags):
    -   GHC options, also known as compiler flags, provide fine-grained control over various aspects of the Glasgow Haskell Compiler (GHC) and the compilation process.
    -   These options allow you to tailor how your Haskell code is compiled and executed. You can use them to optimize performance, enable debugging, or configure other compiler-related behaviors.

```text
Common project-config
  default-language:       Haskell2010

  default-extensions:     NoImplicitPrelude
                          OverloadedStrings
                          ExplicitForAll
                          ScopedTypeVariables
                          DeriveGeneric
                          StandaloneDeriving
                          DeriveLift
                          GeneralizedNewtypeDeriving
                          DeriveFunctor
                          DeriveFoldable
                          DeriveTraversable
                          LambdaCase
                          MultiParamTypeClasses
                          TypeOperators
                          FlexibleInstances
                          NamedFieldPuns
                          TypeFamilies
                          FlexibleContexts
                          DeriveAnyClass
                          DerivingStrategies
                          DerivingVia
                          DataKinds
                          PatternGuards
                          OverloadedRecordFields
                          GADTs
                          ImportQualifiedPost
                          MultiWayIf
                          RankNTypes
                          RecordWildCards
                          TemplateHaskell
                          TypeApplications
                          UndecidableInstances
                          DuplicateRecordFields

  ghc-options:            -Wall
                          -Wcompat
                          -Wincomplete-record-updates
                          -Wnoncanonical-monad-instances
                          -Wredundant-constraints
                          -Wincomplete-uni-patterns
                          -Wunused-packages
                          -Widentities
                          -fno-ignore-interface-pragmas
                          -fno-omit-interface-pragmas
                          -fobject-code
                          -fno-specialise
                          -fno-spec-constr
                          -fno-strictness

```

### Step 4: Library Configuration (Replace with Your Specifics)

-   For the library section, you can specify the project's source directories and exposed modules. Make sure to customize this section with your module names, directory structure, and dependencies:

```text
Library
  import:           project-config
  hs-source-dirs:   <MODULE_FOLDERS_OR_FILES_DIRECTORY_NAME>
  exposed-modules:
                    <MODULE_NAME>.<SUB_MODULE_NAME>.<NAME_OF_THE_FILE>

  build-depends:
                    <PACKAGE_NAME_1>
                  , <PACKAGE_NAME_2>
                  , <PACKAGE_NAME_3>
                  , ...

```

### Step 5: Executable Configuration (Replace with Your Specifics)

-   If your project includes executable files, define their configurations in this section. Adjust the settings according to your project's requirements:

```text
executable <EXECUTABLE_FILE_NAME>
  default-language: Haskell2010
  main-is: <EXECUTABLE_FILE_NAME>.hs
  hs-source-dirs:      <EXECUTABLE_FILE_DIRECTORY_NAME>
  ghc-options:         -threaded -rtsopts "-with-rtsopts=-T"
  build-depends:        <PACKAGE_NAME_1>
                      , <PACKAGE_NAME_2>
                      , <PACKAGE_NAME_3>
                      , ...
```

import MDXLessonLayout from "@/src/components/lms/Lesson/MDXLessonLayout.tsx";
export default ({ children }) => <MDXLessonLayout>{children}</MDXLessonLayout>;
